/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

#include "prelude.h"

// tri par insertion

void insertion_sort(int a[], int n) {
  for (int i = 1; i < n; i++) {
    // invariant: a[0..i[ est trié
    int v = a[i];
    int j = i;
    while (j > 0 && a[j-1] > v) {
      a[j] = a[j-1];
      j--;
    }
    a[j] = v;
  }
}

// variante du tri par insertion, qui utilise une recherche
// dichotomique pour trouver la position d'insertion

// renvoie la position immédiatement à droite de v dans a[lo..hi[
// (en supposant a[lo..hi[ trié par ordre croissant)
int binary_search_right(int v, int a[], int lo, int hi) {
  assert(lo <= hi);
  while (lo < hi) {
    int mid = lo + (hi - lo) / 2;
    if (a[mid] <= v) lo = mid+1; else hi = mid;
  }
  return hi;
}

void binary_sort(int a[], int n) {
  for (int i = 1; i < n; i++) {
    // invariant: a[0..i[ est trié
    int v = a[i];
    int m = binary_search_right(v, a, 0, i);
    for (int j = i; j > m; j--) {
      a[j] = a[j-1];
    }
    a[m] = v;
  }
}
